;;;********************************************************************
;;;                      
;;;                              SHPON.LSP v.1
;;;                                 3.06.02
;;;                   Copyright,2002        ..
;;;********************************************************************

(defun c:shpo (/ dcl_id)
  (setq	sosnap	(getvar "osmode")
	cmd	(getvar "cmdecho")
	d2	nil
	nam1	(findfile "support/Shpon/shpon.dcl")
        dcl_id	(load_dialog nam1)
	wrong	1
  ) 
  (if (new_dialog "shpon" dcl_id)
    (progn
      (mode_tile "d1" 2)
      (mode_tile "vid" 1)
      (mode_tile "dli" 1)
      (mode_tile "l1" 1)
      (mode_tile "l3" 1)
      (action_tile "d1" "(setq d2 $value) (update)")
      (action_tile "vid" "(progn (setq case $value) (show_im2) (dliv) (dlin))")
      (action_tile "dli" "(progn (setq case2 $value) (dliv))")
      (action_tile "l1" "(setq l5 $value l2 l5)")
      (action_tile "l3" "(setq l4 $value l2 (nth (+ (atoi l4) nnach) r2))")
      (action_tile "accept" "(okey)")
      (action_tile "cancel" "(progn (setq wrong 0) (done_dialog 0))")
      (action_tile "help" "(ab_prog)")
      (start_dialog)
      (unload_dialog dcl_id)
    )
    (exit)
  )
  (if (/= wrong 0) (otris))
)

;=====      =====
;==========    ===========

(defun okey ()
  (cond ((= d2 nil) (set_tile "attention" "   "))
	((and (= case2 "dlnp") (= (atof l5) 0.0))
	 (set_tile "attention" "    "))
	((or (< d 6) (> d 130))
	 (set_tile "attention" "    6   130   "))
	((or
	   (and (>= d 6) (<= d 130) (= case2 "dlns"))
	   (and (>= d 6) (<= d 130) (= case2 "dlnp") (/= (atof l5) 0.0)))
	   (done_dialog))
  )
)

;=====      =====

(defun update ()
  (setq	nam	(findfile "support/Shpon/shpon.dat")
 	x	(open nam "r")
	a	(read-line x)
	aa	(read a)
	d 	(atof d2)
	r2	(cdr (assoc 'l aa))
	st	""
  )
  (cond	((and (>= d 6) (<= d 8))
	 (setq	r1 (cdr (assoc '6 aa)) nnach 0 nkon 7)
	)
	((and (> d 8) (<= d 10))
	 (setq r1 (cdr (assoc '8 aa)) nnach 0 nkon 12)
	)
	((and (> d 10) (<= d 12))
	 (setq r1 (cdr (assoc '10 aa)) nnach 1 nkon 14)
	)
	((and (> d 12) (<= d 17))
	 (setq r1 (cdr (assoc '12 aa)) nnach 2 nkon 16)
	)
	((and (> d 17) (<= d 22))
	 (setq r1 (cdr (assoc '17 aa)) nnach 4 nkon 18)
	)
	((and (> d 22) (<= d 30))
	 (setq r1 (cdr (assoc '22 aa)) nnach 6 nkon 20)
	)
	((and (> d 30) (<= d 38))
	 (setq r1 (cdr (assoc '30 aa)) nnach 8 nkon 22)
	)
	((and (> d 38) (<= d 44))
	 (setq r1 (cdr (assoc '38 aa)) nnach 10 nkon 24)
	)
	((and (> d 44) (<= d 50))
	 (setq r1 (cdr (assoc '44 aa)) nnach 12 nkon 25)
	)
	((and (> d 50) (<= d 58))
	 (setq r1 (cdr (assoc '50 aa)) nnach 14 nkon 28)
	)
	((and (> d 58) (<= d 65))
	 (setq r1 (cdr (assoc '58 aa)) nnach 15 nkon 26)
	)
	((and (> d 65) (<= d 75))
	 (setq r1 (cdr (assoc '65 aa)) nnach 16 nkon 26)
	)
	((and (> d 75) (<= d 85))
	 (setq r1 (cdr (assoc '75 aa)) nnach 17 nkon 26)
	)
	((and (> d 85) (<= d 95))
	 (setq r1 (cdr (assoc '85 aa)) nnach 18 nkon 26)
	)
	((and (> d 95) (<= d 110))
	 (setq r1 (cdr (assoc '95 aa)) nnach 19 nkon 26)
	)
	((and (> d 110) (<= d 130))
	 (setq r1 (cdr (assoc '110 aa)) nnach 20 nkon 32)
	)
	((or (< d 6) (> d 130))
	 (setq r1 (cdr (assoc '0 aa)) nnach 33 nkon 33)
	)
  )
  (setq b_t     (car r1)
        h_t     (cadr r1)
        tval_t  (caddr r1)
        tvtul_t (cadddr r1)
	j	nnach
	l2	(nth nnach r2)	;  
	case	"shva1"		;  
	case2	"dlns"		;  
	l5	"0"		;  
  )
  (show_im2)			;   
    (mode_tile "vid" 0)		;   
    (set_tile "vid" case)	;   
    (set_tile "dli" case2)	;   
    (set_tile "l1" " ")		;   
    (mode_tile "dli" 1)		;   
    (mode_tile "l1" 1)		;   
    (mode_tile "l3" 1)		;   
  (set_tile "b1" b_t)
  (set_tile "h1" h_t)
  (set_tile "tval1" tval_t)
  (set_tile "tvtul1" tvtul_t)
  (set_tile "attention" " ")
  (start_list "l3")
  (while (<= j nkon)
    (setq st (nth j r2))
    (add_list st)
    (setq j (1+ j))
  )
  (end_list)
)

;===== =====

(defun show_im2 ( )
   (setq orx (dimx_tile "image")
	 aby (dimy_tile "image")
   )
   (cond
      ((= case "shva1") (setq name1 "support/Shpon/shpon(sh_va).slb"))
      ((= case "shvt1") (setq name1 "support/Shpon/shpon(sh_vt).slb"))
      ((= case "shsb1") (setq name1 "support/Shpon/shpon(sh_sb).slb"))
      ((= case "shsv1") (setq name1 "support/Shpon/shpon(sh_sv).slb"))
   )
   (start_image "image")
   (fill_image 0 0 orx aby 444)
   (slide_image 0 0 orx aby name1)
   (end_image)
)

;===== ""=====

(defun ab_prog ( )
  (setq help_pr
    (list "                             "
	  "         8788,"
	  "      23360."
	  "      \" -"
	  "  \" .. ."
	  "  !    "
	  "    (enter),    ."
	  "     :  "
	  "         , "
	  "     E-mail: klf02@yandex.ru"
   )
  )
  (if (not (new_dialog "ab_text" DCL_ID)) (exit))
  (start_list "ab_progr")
  (mapcar 'add_list help_pr)
  (end_list)
  (action_tile  "accept" "(done_dialog)")
  (start_dialog)
)

;===== / =====

(defun dliv ()
   (cond
      ((= case2 "dlnp") (progn (mode_tile "l1" 0) (mode_tile "l3" 1)))
      ((= case2 "dlns") (progn (mode_tile "l3" 0) (mode_tile "l1" 1)))
   )
)
;=====-  ""=====

(defun dlin ()
  (if (= case "shsv1")
    (progn (mode_tile "dli" 0)
    )
    (progn (mode_tile "dli" 1)
	   (mode_tile "l1" 1)
	   (mode_tile "l3" 1)
    )
  )
)

;==========

(defun otris ()
  (setq	b     (atof b_t)
	h     (atof h_t)
	tval  (atof tval_t)
	tvtul (atof tvtul_t)
  )
  (setvar "cmdecho" 0)
  (setvar "osmode" 0)
  (cond	((= case "shva1") (shva))
	((= case "shvt1") (shvt))
	((= case "shsb1") (shsb))
	((= case "shsv1") (shsv))
  )
)

;=====      =====

(defun param ()
  (setq r     (/ d 2)
	05b   (/ b 2)
	x     (sqrt (- (* r r) (* 05b 05b)))
	alfa  (atan (/ 05b x))
	p9    (polar p8 (+ (/ pi 2) alfa) r)
	p10   (polar p8 (- (/ pi 2) alfa) r)
	raz   (- r x)
	gl1   (- tval raz)
	p11   (polar p9 (* pi -0.5) gl1)
	p12   (polar p10 (* pi -0.5) gl1)
	gl2   (+ tvtul raz)
	p6    (polar p9 (* pi 0.5) gl2)
	p7    (polar p10 (* pi 0.5) gl2)
	p4    (polar p11 (* pi 0.5) h)
	p5    (polar p12 (* pi 0.5) h)
  )
)

;=====       =====

(defun shva ()
  (setq p8 (getpoint "\n   : "))
  (param)
  (command "pline" p9 "w" 0 0 p11 p12 p10 "")
  (setq poli1 (entlast))
  (command "arc" p9 "ce" p8 p10)
  (setq duga1 (entlast))
  (command "arc" p10 "ce" p8 p9)
  (setq duga2 (entlast))
  (command "change" duga2 "" "p" "c" 1 "lt" "" "")
  (setq	p13 (polar p8 pi (+ r 3))
	p14 (polar p8 0 (+ r 3))
	p15 (polar p8 (/ pi 2) (+ r 3))
	p16 (polar p8 (* pi 1.5) (+ r 3))
  )
  (command "line" p13 p14 "")
  (setq os1 (entlast))
  (command "line" p15 p16 "")
  (setq os2 (entlast))
  (command "change" os1	os2 "" "p" "c" 1 "lt" "ACAD_ISO10W100" "")
  (setvar "osmode" sosnap)
  (setq	p81  (getpoint p8 "\n   : ")
	alfa (angle p8 p81)
	beta (+ 270 (/ (* 180 alfa) pi))
  )
  (command "rotate" poli1 duga1 duga2 os1 os2 "" p8 beta)
  (setvar "cmdecho" cmd)
)

;=====       =====

(defun shvt ()
  (setq p8 (getpoint "\n   : "))
  (param)
  (command "pline" p9 "w" 0 0 p6 p7 p10 "")
  (setq poli2 (entlast))
  (command "arc" p9 "ce" p8 p10)
  (setq duga1 (entlast))
  (setq	p13 (polar p8 pi (+ r 3))
	p14 (polar p8 0 (+ r 3))
	p15 (polar p8 (/ pi 2) (+ r tvtul 3))
	p16 (polar p8 (* pi 1.5) (+ r 3))
  )
  (command "line" p13 p14 "")
  (setq os1 (entlast))
  (command "line" p15 p16 "")
  (setq os2 (entlast))
  (command "change" os1	os2 "" "p" "c" 1 "lt" "ACAD_ISO10W100" "")
  (setvar "osmode" sosnap)
  (setq	p81  (getpoint p8 "\n   : ")
	alfa (angle p8 p81)
	beta (+ 270 (/ (* 180 alfa) pi))
  )
  (command "rotate" poli2 duga1 os1 os2 "" p8 beta)
  (setvar "cmdecho" cmd)
)

;=====     =====

(defun shsb ()
  (setq p8 (getpoint "\n   : "))
  (param)
  (command "pline" p9 "w" 0 0 p11 p12 p10 "")
  (setq poli1 (entlast))
  (command "pline" p9 "w" 0 0 p6 p7 p10 "")
  (setq poli2 (entlast))
  (command "pline" p11 "w" 0 0 p4 p5 p12 p11 "")
  (setq sh_ka (entlast))
  (command "arc" p9 "ce" p8 p10)
  (setq duga1 (entlast))
  (setq	p13 (polar p8 pi (+ r 3))
	p14 (polar p8 0 (+ r 3))
	p15 (polar p8 (/ pi 2) (+ r tvtul 3))
	p16 (polar p8 (* pi 1.5) (+ r 3))
  )
  (command "line" p13 p14 "")
  (setq os1 (entlast))
  (command "line" p15 p16 "")
  (setq os2 (entlast))
  (command "change" os1	os2 "" "p" "c" 1 "lt" "ACAD_ISO10W100" "")
  (setvar "osmode" sosnap)
  (setq	p81  (getpoint p8 "\n   : ")
	alfa (angle p8 p81)
	beta (+ 270 (/ (* 180 alfa) pi))
  )
  (command "rotate" poli1 poli2	sh_ka duga1 os1	os2 "" p8 beta)
  (setvar "cmdecho" cmd)
)

;=====     =====

(defun shsv ()
  (setq	l   (atof l2)
	k1  (getpoint "\n  : ")
	05b (/ b 2)
	k2  (polar k1 0 05b)
	k3  (polar k2 0 l)
	k4  (polar k2 (* pi 0.5) 05b)
	k5  (polar k2 (* pi 1.5) 05b)
	k6  (polar k3 (* pi 0.5) 05b)
	k7  (polar k3 (* pi 1.5) 05b)
  )
  (command "line" k4 k6 "")
  (setq lin1 (entlast))
  (command "line" k5 k7 "")
  (setq lin2 (entlast))
  (command "arc" k4 "ce" k2 k5)
  (setq duga1 (entlast))
  (command "arc" k7 "ce" k3 k6)
  (setq duga2 (entlast))
  (setq	k14 (polar k4 (* pi 0.5) 3)
	k15 (polar k5 (* pi 1.5) 3)
	k16 (polar k6 (* pi 0.5) 3)
	k17 (polar k7 (* pi 1.5) 3)
  )
  (command "line" k14 k15 "")
  (setq os1 (entlast))
  (command "line" k16 k17 "")
  (setq os2 (entlast))
  (command "change" os1	os2 "" "p" "c" 1 "lt" "ACAD_ISO10W100" "")
  (setvar "osmode" sosnap)
  (setq	k11  (getpoint k1 "\n   : ")
	alfa (angle k1 k11)
	beta (/ (* 180 alfa) pi)
  )
  (command "rotate" lin1 lin2 duga1 duga2 os1 os2 "" k1 beta)
  (setvar "cmdecho" cmd)
)